#include <SDL/SDL.h>
#include "Sprite.h"

class App {
public:
  explicit App(size_t win_width, size_t win_height, bool fullscreen_mode) :
    m_window_width(win_width), m_window_height(win_height), m_fullscreen(fullscreen_mode) {
  }

  void Run();

private:

  void Draw();
  void Update(double dt);
  void Resize(size_t width, size_t height);
  void ProcessEvents();

private:
  size_t m_window_width;
  size_t m_window_height;
  bool m_fullscreen;
  bool is_done;
  SDL_Surface* m_screen;

  SpritePtr m_litery;
  SpritePtr m_liczby;
  SpritePtr m_liczby_loop;
};

