#ifndef ENGINE_H_
#define ENGINE_H_

#include <string>
#include <SDL/SDL_opengl.h>

#include "SpriteConfig.h"
#include "Renderer.h"

class Engine {
public:
  static Engine& Get() {
    static Engine engine;
    return engine;
  }

  void Load() {
    m_spriteConfig.reset(new SpriteConfig::SpriteConfig());
    m_renderer.reset(new Renderer::Renderer());
  }

  SpriteConfigPtr SpriteConfig() {
    return m_spriteConfig;
  }

  RendererPtr Renderer() {
    return m_renderer;
  }

private:
  SpriteConfigPtr m_spriteConfig;
  RendererPtr m_renderer;

};

#endif /* ENGINE_H_ */
